!DIR$ FIXEDFORMLINESIZE:132
      subroutine am_pnts_vol_rec(fail)
      use math_blocks
      use rte_blocks
      use header_types
      implicit none

      logical*4, intent(out) :: fail

      N0 = 3
      N1 = Nscth
      N2 = Nsphi
      L1 = Lx
      L2 = Ly
      L3 = Lz

      if(compute_u) then
         nmem = nmem + int8(L1)*int8(L2)*int8(L3)*int8(nword)
      end if

      if(compute_J) then
         nmem = nmem + int8(N0)*int8(L1)*int8(L2)*int8(L3)*int8(nword)
      end if

       if(compute_I) then
         nmem = nmem + int8(N1)*int8(N2)*int8(L1)*int8(L2)*int8(L3)*int8(nword)
      end if
 
      if(nmem .gt. nmem_tot) then
         write(*,*) '** AM_PNTS_VOL_REC: Not enough free memory to proceed ***************'
         write(*,*) '** [Required Memory] : ', sngl(nmem*nano)    , ' Gb *****************'
         write(*,*) '**  [Allowed Memory] : ', sngl(nmem_tot*nano), ' Gb *****************'
         write(*,*) '** NOTE: [Allowed Memory] =/= [Available Memory] ********************'
         write(*,*) '** RECOMENDATION: Check parameters nmem_tot, Lx, Ly, Lz, Nscth, Nsphi'
         fail = .true.
         return
      else
         fail = .false.
      end if

      if(compute_u) then
         allocate(u3D(1:L1,1:L2,1:L3))
         u3D = dzero
      end if
         
      if(compute_J) then
         allocate(J4D(1:N0,1:L1,1:L2,1:L3))
         J4D = dzero
      end if
 
      if(compute_I) then
         write(*,*) 'A 5-dimensional array for I(x,y,z,theta,phi) needs to be allocated...' 
         write(*,*) 'This can take some time if the array is large. Please wait a bit...'
         allocate(I5D(1:N1,1:N2,1:L1,1:L2,1:L3))
         I5D = dzero
      end if

      return
      end
