!DIR$ FIXEDFORMLINESIZE:132
      include 'include/mkl_vsl.f'
      include 'include/math_blocks.f'
      include 'include/rte_blocks.f'
      include 'include/header_types.f'
      include 'include/file_types.f'
      program dd
      use rte_blocks
      use header_types
      use file_types
      implicit none

      character*32 name
      character*32 filetype
      integer*4  mode, errcode
      logical*4 flag

 401  format(a32)

      goto 2
 1    continue
      write(*,*) 'Error openning input file. Please try again'

 2    continue
      write(*,*) 'Give input filename'
      read(*,401) name

      open(unit=80, file=name, status='old', access='direct', recl=len, err=1)

      read(80,rec=1,err=3) string
      Filetype = string%Filetype
      call check_filetype(filetype, flag)
      if(flag) then
         write(*,*) 'Input file has a wrong format; exiting'
         stop
      end if

      write(*,*) 'Filetype:', string%Filetype

      call decomp_string()
   
      call report_pars('*dd*')

      goto 4

 3    continue
      write(*,*) 'Error reading fileheader ...'
      write(*,*) 'The input file may have a wrong format. Try another file'
      goto 2
 4    continue

 5    continue

 402  format(a16, a8, a9)
 403  format(a33)
      write(*,*) 'How do you want to specify the coordinates?'
      write(*,402) '1) In units of [', Units, ']     [1]'
      write(*,403) '2) Using integer indexes      [2]'
      read(*,*) mode
      if     (mode .eq. 1) then
         continue
      else if(mode .eq. 2) then
         continue
      else
         write(*,*) 'Incorrect input; please type 1 or 2'
         goto 5
      end if

      if     ( (filetype .eq. ft( 1)) .or. (filetype .eq. ft( 1 + nft)) ) then
         call dd_u_3D(mode,errcode)
      else if( (filetype .eq. ft( 2)) .or. (filetype .eq. ft( 2 + nft)) ) then
         call dd_u_CYL(mode,errcode)
      else if( (filetype .eq. ft( 3)) .or. (filetype .eq. ft( 3 + nft)) ) then
         call dd_u_2D(mode,errcode)
      else if( (filetype .eq. ft( 4)) .or. (filetype .eq. ft( 4 + nft)) ) then
         call dd_u_2D(mode,errcode)
      else if( (filetype .eq. ft( 5)) .or. (filetype .eq. ft( 5 + nft)) ) then
         write(*,*) 'This is an ASCII file, you can view it directly'
      else if( (filetype .eq. ft( 6)) .or. (filetype .eq. ft( 6 + nft)) ) then
         write(*,*) 'This is an ASCII file, you can view it directly'
      else if( (filetype .eq. ft( 7)) .or. (filetype .eq. ft( 7 + nft)) ) then
         write(*,*) 'This filetype is not yet ilplemented; exiting'
      else if( (filetype .eq. ft( 8)) .or. (filetype .eq. ft( 8 + nft)) ) then
         write(*,*) 'This filetype is not yet ilplemented; exiting'
      else if( (filetype .eq. ft( 9)) .or. (filetype .eq. ft( 9 + nft)) ) then
         write(*,*) 'This filetype is not yet ilplemented; exiting'
      else if( (filetype .eq. ft(10)) .or. (filetype .eq. ft(10 + nft)) ) then
         write(*,*) 'This filetype is not yet ilplemented; exiting'
      else if( (filetype .eq. ft(11)) .or. (filetype .eq. ft(11 + nft)) ) then
         write(*,*) 'This filetype is not yet ilplemented; exiting'
      else if( (filetype .eq. ft(12)) .or. (filetype .eq. ft(12 + nft)) ) then
         write(*,*) 'This filetype is not yet ilplemented; exiting'
      else if( (filetype .eq. ft(13)) .or. (filetype .eq. ft(13 + nft)) ) then
         call dd_J_3D(mode,errcode)
      else if( (filetype .eq. ft(14)) .or. (filetype .eq. ft(14 + nft)) ) then
         call dd_J_CYL(mode,errcode)
      else if( (filetype .eq. ft(15)) .or. (filetype .eq. ft(15 + nft)) ) then
         call dd_J_2D(mode,errcode)
      else if( (filetype .eq. ft(16)) .or. (filetype .eq. ft(16 + nft)) ) then
         call dd_J_2D(mode,errcode)
      else if( (filetype .eq. ft(17)) .or. (filetype .eq. ft(17 + nft)) ) then
         write(*,*) 'This is an ASCII file, you can view it directly'
      else if( (filetype .eq. ft(18)) .or. (filetype .eq. ft(18 + nft)) ) then
         write(*,*) 'This is an ASCII file, you can view it directly'
      else if( (filetype .eq. ft(19)) .or. (filetype .eq. ft(19 + nft)) ) then
         write(*,*) 'This filetype is not yet ilplemented; exiting'
      else if( (filetype .eq. ft(20)) .or. (filetype .eq. ft(20 + nft)) ) then
         write(*,*) 'This filetype is not yet ilplemented; exiting'
      else if( (filetype .eq. ft(21)) .or. (filetype .eq. ft(21 + nft)) ) then
         write(*,*) 'This filetype is not yet ilplemented; exiting'
      else if( (filetype .eq. ft(22)) .or. (filetype .eq. ft(22 + nft)) ) then
         write(*,*) 'This filetype is not yet ilplemented; exiting'
      else if( (filetype .eq. ft(23)) .or. (filetype .eq. ft(23 + nft)) ) then
         write(*,*) 'This filetype is not yet ilplemented; exiting'
      else if( (filetype .eq. ft(24)) .or. (filetype .eq. ft(24 + nft)) ) then
         write(*,*) 'This filetype is not yet ilplemented; exiting'
      else if( (filetype .eq. ft(25)) .or. (filetype .eq. ft(25 + nft)) ) then
         call dd_rec_I_5D(mode,errcode)
      else if( (filetype .eq. ft(26)) .or. (filetype .eq. ft(26 + nft)) ) then
         call dd_cyl_I_4D(mode,errcode)
      else if( (filetype .eq. ft(27)) .or. (filetype .eq. ft(27 + nft)) ) then
         call dd_rec_I_4D(mode,errcode)
      else if( (filetype .eq. ft(28)) .or. (filetype .eq. ft(28 + nft)) ) then
         call dd_rec_I_4D(mode,errcode)
      else if( (filetype .eq. ft(29)) .or. (filetype .eq. ft(29 + nft)) ) then
         call dd_cyl_I_3D(mode,errcode)
      else if( (filetype .eq. ft(30)) .or. (filetype .eq. ft(30 + nft)) ) then
         call dd_cyl_I_3D(mode,errcode)
      else if( (filetype .eq. ft(31)) .or. (filetype .eq. ft(31 + nft)) ) then
         write(*,*) 'This filetype is not yet ilplemented; exiting'
      else if( (filetype .eq. ft(32)) .or. (filetype .eq. ft(32 + nft)) ) then
         call dd_cyl_I_2D(mode,errcode)
      else if( (filetype .eq. ft(33)) .or. (filetype .eq. ft(33 + nft)) ) then
         write(*,*) 'This filetype is not yet ilplemented; exiting'
      else if( (filetype .eq. ft(34)) .or. (filetype .eq. ft(34 + nft)) ) then
         write(*,*) 'This filetype is not yet ilplemented; exiting'
      else if( (filetype .eq. ft(35)) .or. (filetype .eq. ft(35 + nft)) ) then
         write(*,*) 'This filetype is not yet ilplemented; exiting'
      else if( (filetype .eq. ft(36)) .or. (filetype .eq. ft(36 + nft)) ) then
         write(*,*) 'This filetype is not yet ilplemented; exiting'
      else
         write(*,*) 'DD Unexpected error: Unrecognized FILETYPE'
         stop
      end if

      if(errcode .ne. 0) then
         write(*,*) 'There were errors reading and displaying binary data'
         write(*,*) '................... errcode:', errcode
      end if

      stop
      end
