!DIR$ FIXEDFORMLINESIZE:132
      subroutine job_isrc_None()
      use math_blocks
      use rte_blocks
      use header_types
      implicit none
c
c----------------- Local variables -------------------------------
c
      integer*8 iw, ns, nv, nu, na, life

      logical*4 absorbed

      real*4    perc
      real*4    xw, yw, zw, dx, dy, dz, sx, sy, sz
      real*4    cth_ir, sth_ir, cph_ir, sph_ir, del_ir

      integer*4 ir, iu

      if(Collimated_Source) then
         write(*,*) 'JOB_ICRC_NONE unexpected error: Collimated_Source=T'
         return
      end if

      if(.not. Compute_None) then
         write(*,*) 'JOB_ICRC_NONE unexpected error: Compute_None=F'
         return
      end if
c
c----------------- Initialization -------------------------------
c

      call discard_rnums()  ! Discard first NR random numbers in each stream
      call discard_unums()  ! Discard first NR random numbers in each stream

      call make_rnums()     ! Random streams first-run
      call make_unums()     ! Random streams first-run

      nv = 0
      nu = 0
      ir = 0
      iu = 0

      na = 0 

c
c---------- Loop over random walkers -------------------------------
c 

 400  format(1H+, a7, f5.1, a10)

      do 100, iw=1,nw

      if(mod(iw,nc) .eq. 0) then
         perc = 100.0*float(iw)/float(nw)
         write(6,400) '       ', perc, '% complete'
      end if

c............ a) Initial position

c$$$      xw = x0
c$$$      yw = y0
      xw = rzero
      yw = rzero
      zw = z0

c............ b) First step

      ir = ir + 1

      del_ir = del(ir)

      iu = iu + 1
      sx = ust(iu)*ucp(iu)
      sy = ust(iu)*usp(iu)
      sz = uct(iu)
      if(iu .eq. nr) then
         nu = nu + 1
         call make_unums()
         iu = 0
      end if

      dx = del_ir*sx
      dy = del_ir*sy
      dz = del_ir*sz

      xw = xw + dx
      yw = yw + dy
      zw = zw + dz

      if(bin(ir) .eq. 1) then
         absorbed = .true.
      else
         absorbed = .false.
      end if
      
      if(ir .eq. nr) then
         nv = nv + 1
         call make_rnums()
         ir = 0
      end if

      if(zw .lt. zsmin) goto 100
c$$$      if(yw .lt. ysmin) goto 100
c$$$      if(xw .lt. xsmin) goto 100

      if(zw .gt. zsmax) goto 100
c$$$      if(yw .gt. ysmax) goto 100
c$$$      if(xw .gt. xsmax) goto 100

      if(absorbed) then
         na = na + 1
         goto 100
      end if

c............ c) The rest of photon life (after the first step)

 10   continue
      
      ir = ir + 1

      cth_ir = cth(ir)
      sth_ir = sth(ir)
      cph_ir = cph(ir)
      sph_ir = sph(ir)
      del_ir = del(ir)

      call rotate_s(cth_ir,sth_ir,cph_ir,sph_ir,sx,sy,sz)

      dx = del_ir*sx
      dy = del_ir*sy
      dz = del_ir*sz

      xw = xw + dx
      yw = yw + dy
      zw = zw + dz

      if(bin(ir) .eq. 1) then
         absorbed = .true.
      else
         absorbed = .false.
      end if
      
      if(ir .eq. nr) then
         nv = nv + 1
         call make_rnums()
         ir = 0
      end if

      if(zw .lt. zsmin) goto 100
c$$$      if(yw .lt. ysmin) goto 100
c$$$      if(xw .lt. xsmin) goto 100

      if(zw .gt. zsmax) goto 100
c$$$      if(yw .gt. ysmax) goto 100
c$$$      if(xw .gt. xsmax) goto 100

      if(absorbed) then
         na = na + 1
         goto 100
      end if

      goto 10

 100  continue
      close(unit=6)

c
c---------- End of random walks ---------------------------
c

      call stop_rstreams() ! Deinitialize random streams str1,str2,str3,str4
      call stop_ustreams() ! Deinitialize random streams str1,str2,str3,str4

      ns   = (nv-1)*int8(nr) + int8(ir)
      life = nint(dfloat(ns)/dfloat(nw))

 402  format(a46,i14)
      write(*,*)   '------------------------------------------------------------'
      write(*,402) '                      Total number of photons:', nw
      write(*,402) '                   Number of absorbed photons:', na
      write(*,402) '          Number of steps made by all walkers:', ns
      write(*,402) 'Number of steps per one walker (average life):', life
      write(*,402) '                       Number of vectors used:', nv
      write(*,402) '                     Number of u-vectors used:', nu
      write(*,*)   '------------------------------------------------------------'
      
      return
      end
