!DIR$ FIXEDFORMLINESIZE:132
      subroutine dd_J_CYL(mode, errcode)
      use rte_blocks
      implicit none

      integer*4, intent(in)  :: mode
      integer*4, intent(out) :: errcode

      integer*8   irec, n, n_max

      real*4      funrho, funz
      real*4      rho, z, rho_of_irho, z_of_iz

      integer*4   k, l, irho, iz, i0

      integer*4 ind

      real(nword), allocatable, dimension(:)     :: v
      real(nword), allocatable, dimension(:,:,:) :: J

      errcode = 0

      n0 = 2
      n_max = int8(n0)*int8(lrho)*int8(lz)
      allocate(v(1:nline))
      allocate(J(1:n0,1:lrho,1:lz))

      irec = 2
      read(80,rec=irec,err=1002) (v(l), l=1,nline)
      k = 0
      n = 0
      do 2, iz  =1,lz
      do 2, irho=1,lrho
      do 2, i0  =1,n0
      k=k+1
      n=n+1
      J(i0,irho,iz) = v(k)
      if(k .eq. nline) then
         if(n .lt. n_max) then
            irec = irec+1 
            read(80,rec=irec,err=1002) (v(l), l=1,nline)
            k = 0
         else
            continue
         end if
      end if
 2    continue

      close(unit=80,err=1003)
      write(*,*) irec, 'records successfully read'

      deallocate(v)

 100  continue

      write(*,*) '********* J(r)=J(rho, z)=(Jrho,Jz). Make a choice: *********'
      write(*,*) '   Display J(rho     , z   ) as a function of (rho,z)    [1]'
      write(*,*) '   Display J(rho     , z=z0) as a function of rho        [2]'
      write(*,*) '   Display J(rho=rho0, z   ) as a function of z          [3]'
      write(*,*) '************************************************************'

      read(*,*) ind
      if((ind .lt. 1) .or. (ind .gt. 3)) then
         write(*,*) 'Response is outside of range or incorrect. Try again'
         goto 100
      end if
c
c------------- Getting integer idexes -------------------------
c
      if      (mode .eq. 1) then
         call gip_u_CYL(ind, irho, iz)
      else if (mode .eq. 2) then
         call gii_u_CYL(ind, irho, iz)
      else
         errcode = 1
         return
      end if

c
c------------- Writing data out --------------------------------------
c

      IF     (ind .eq. 1) THEN

         open(unit=70, file='J_rho_z',status='unknown')

         do 11, iz=1,Lz
         z = z_of_iz(iz)
         do 11, irho=1,Lrho
         rho    = rho_of_irho(irho)
         funrho = J(1,irho,iz)
         funz   = J(2,irho,iz)
         write(70,*) rho, z, funrho, funz
 11      continue

         write(*,*) '.... Output written to file "J_rho_z" '
         write(*,*) '............ Format: rho, z, Jrho, Jz '

      ELSE IF(ind .eq. 2) THEN

         open(unit=70, file='J_rho',status='unknown')

         do 12, irho=1,Lrho
         rho    = rho_of_irho(irho)
         funrho = J(1,irho,iz)
         funz   = J(2,irho,iz)
         write(70,*) rho, funrho, funz
 12      continue

         write(*,*) '....... Output written to file "J_rho" '
         write(*,*) '............... Format:  rho, Jrho, Jz '

      ELSE IF(ind .eq. 3) THEN

         open(unit=70, file='J_z',status='unknown')

         do 13, iz=1,Lz
         z = z_of_iz(iz)
         funrho = J(1,irho,iz)
         funz   = J(2,irho,iz)
         write(70,*) z, funrho, funz
 13      continue

         write(*,*) '....... Output written to file "J_z" '
         write(*,*) '................ Format: z, Jrho, Jz '

      ELSE

         write(*,*) 'Incorrect index (should be 1<=ind<=3); please try again'
         goto 100

      END IF

      close(unit=70)

      write(*,*) 'Make another choice to display more data'
      write(*,*) '============================================================'
      write(*,*) '============================================================'

      goto 100

      return

 1002 continue
      write(*,*) 'dd_J_CYL: Error reading binary data'
      errcode = 1002
      return

 1003 continue
      write(*,*) 'dd_J_CYL: Error closing input file'
      errcode = 1003
      return

      end
