!DIR$ FIXEDFORMLINESIZE:132
      subroutine dd_u_2D(mode, errcode)
      use rte_blocks
      implicit none

      integer*4, intent(in)  :: mode
      integer*4, intent(out) :: errcode

      integer*8   irec, n, n_max

      real*4      fun
      real*4      x, y, x_of_ix, y_of_iy

      integer*4   k, l, ix, iy

      integer*4 ind

      real(nword), allocatable, dimension(:)   :: v
      real(nword), allocatable, dimension(:,:) :: u

      errcode = 0

      n_max = int8(lx)*int8(ly)

      allocate(v(1:nline))
      allocate(u(1:lx,1:ly))

      irec = 2
      read(80,rec=irec,err=1002) (v(l), l=1,nline)

      k = 0
      n = 0
      do 1, iy=1,ly
      do 1, ix=1,lx
      k=k+1
      n=n+1
      u(ix,iy) = v(k)
      if(k .eq. nline) then
         if(n .lt. n_max) then
            irec = irec+1 
            read(80,rec=irec,err=1002) (v(l), l=1,nline)
            k = 0
         else
            continue
         end if
      end if
 1    continue

      close(unit=80,err=1003)
      write(*,*) irec, 'records successfully read'

      deallocate(v)

 100  continue

      write(*,*) '***** u(r) = u(x, y). Make a choice: *******************'
      write(*,*) '   Display u(x   , y   ) as a function of (x,y)      [1]'
      write(*,*) '   Display u(x   , y=y0) as a function of x          [2]'
      write(*,*) '   Display u(x=x0, y   ) as a function of y          [3]'
      write(*,*) '********************************************************'

      read(*,*) ind
      if((ind .lt. 1) .or. (ind .gt. 3)) then
         write(*,*) 'Response is outside of range or incorrect. Try again'
         goto 100
      end if
c
c------------- Getting integer idexes -------------------------
c
      if      (mode .eq. 1) then
         call gip_u_2D(ind, ix, iy)
      else if (mode .eq. 2) then
         call gii_u_2D(ind, ix, iy)
      else
         errcode = 1
         return
      end if

c
c------------- Writing data out --------------------------------------
c

      IF     (ind .eq. 1) THEN

         open(unit=70, file='u_x_y',status='unknown')

         do 11, iy=1,Ly
         y = y_of_iy(iy)
         do 11, ix=1,Lx
         x = x_of_ix(ix)
         fun = u(ix,iy)
         write(70,*) x, y, fun
 11      continue

         write(*,*) '.... Output written to file "u_x_y" '
         write(*,*) '................... Format: x, y, u '

      ELSE IF(ind .eq. 2) THEN

         open(unit=70, file='u_x',status='unknown')

         do 12, ix=1,Lx
         x = x_of_ix(ix)
         fun = u(ix,iy)
         write(70,*) x, fun
 12      continue

         write(*,*) '....... Output written to file "u_x" '
         write(*,*) '...................... Format: x, u  '

      ELSE IF(ind .eq. 3) THEN

         open(unit=70, file='u_y',status='unknown')

         do 13, iy=1,Ly
         y = y_of_iy(iy)
         fun = u(ix,iy)
         write(70,*) y, fun
 13      continue

         write(*,*) '....... Output written to file "u_y" '
         write(*,*) '...................... Format: y, u  '

      ELSE

         write(*,*) 'Incorrect index (should be 1<=ind<=3); please try again'
         goto 100

      END IF

      close(unit=70)

      write(*,*) 'Make another choice to display more data'
      write(*,*) '========================================================'
      write(*,*) '========================================================'

      goto 100

      return

 1002 continue
      write(*,*) 'dd_u_2D: Error reading binary data'
      errcode = 1002
      return

 1003 continue
      write(*,*) 'dd_u_2D: Error closing input file'
      errcode = 1003
      return

      end
