!DIR$ FIXEDFORMLINESIZE:132
      subroutine upd_pnts_vol_cyl(xw, yw, zw, sx, sy, sz)
      use math_blocks
      use rte_blocks
      use header_types
      implicit none  

      real*4, intent(in) :: xw, yw, zw
      real*4, intent(in) :: sx, sy, sz

      real*4    arg, den, sphi, rho
      real*4    ux, uy, srho, spx, spy
      integer*4 irho, iz, irho_of_rho, iz_of_z
      integer*4 iscth, isphi, iscth_of_scth, isphi_of_sphi

      if(zw  .lt. zbmin ) return
      if(zw  .ge. zbmax ) return
      rho = sqrt(xw*xw + yw*yw)
      if(rho .ge. rhomax) return

      irho = irho_of_rho(rho)
      iz   = iz_of_z(zw)

      if(compute_u) then 
         u2D(irho,iz) = u2D(irho,iz) + du
      end if

      if(compute_J) then 
         if(irho .eq. 1) goto 1
         ux = xw/rho
         uy = yw/rho
         srho = sx*ux + sy*uy
         J3D(1,irho,iz) = J3D(1,irho,iz) + srho
 1       continue
         J3D(2,irho,iz) = J3D(2,irho,iz) + sz
      end if

      if(compute_I) then 

         iscth = iscth_of_scth(sz)

         if((rho .le. small) .or. (abs(sz*sz-ru) .lt. small)) then
            I4D(iscth,2:Nsphi-1,irho,iz) =  I4D(iscth,2:Nsphi-1,irho,iz) + sphifrac
            I4D(iscth,1        ,irho,iz) =  I4D(iscth,1        ,irho,iz) + sphihrac
            I4D(iscth,  Nsphi  ,irho,iz) =  I4D(iscth,  Nsphi  ,irho,iz) + sphihrac
          else
            den = sqrt(sx*sx + sy*sy)
            spx = sx/den
            spy = sy/den
            arg = (xw*spx + yw*spy)/rho
            if(arg .gt.  ru) arg =  ru
            if(arg .lt. -ru) arg = -ru
            sphi = acos(arg) / pi
            isphi = isphi_of_sphi(sphi)
            I4D(iscth,isphi,irho,iz) =  I4D(iscth,isphi,irho,iz) + dhalf
            isphi = isphi_of_sphi(two-sphi)
            I4D(iscth,isphi,irho,iz) =  I4D(iscth,isphi,irho,iz) + dhalf
         end if
      end if

      return
      end
