!DIR$ FIXEDFORMLINESIZE:132
      subroutine upd_pnts_vol_rec(xw, yw, zw, sx, sy, sz)
      use math_blocks
      use rte_blocks
      use header_types
      implicit none  

      real*4, intent(in) :: xw, yw, zw
      real*4, intent(in) :: sx, sy, sz

      real*4    arg, den, sphi
      integer*4 ix, iy, iz, ix_of_x, iy_of_y, iz_of_z
      integer*4 iscth, isphi, iscth_of_scth, isphi_of_sphi

      if(xw .lt. xbmin) return
      if(xw .ge. xbmax) return
      if(yw .lt. ybmin) return
      if(yw .ge. ybmax) return
      if(zw .lt. zbmin) return
      if(zw .ge. zbmax) return

      ix = ix_of_x(xw)
      iy = iy_of_y(yw)
      iz = iz_of_z(zw)

      if(compute_u) then 
         u3D(ix,iy,iz) = u3D(ix,iy,iz) + du
      end if

      if(compute_J) then 
         J4D(1,ix,iy,iz) = J4D(1,ix,iy,iz) + sx
         J4D(2,ix,iy,iz) = J4D(2,ix,iy,iz) + sy
         J4D(3,ix,iy,iz) = J4D(3,ix,iy,iz) + sz
      end if

      if(compute_I) then 
c$$$     if(sz .lt. scth_min) return
c$$$     if(sz .gt. scth_max) return
         iscth = iscth_of_scth(sz)

         if(abs(sz*sz-ru) .lt. small) then
            I5D(iscth,2:Nsphi-1,ix,iy,iz) =  I5D(iscth,2:Nsphi-1,ix,iy,iz) + sphifrac
            I5D(iscth,1        ,ix,iy,iz) =  I5D(iscth,1        ,ix,iy,iz) + sphihrac
            I5D(iscth,  Nsphi  ,ix,iy,iz) =  I5D(iscth,  Nsphi  ,ix,iy,iz) + sphihrac
          else
            den  = sqrt(sx*sx + sy*sy)
            arg  = sx/den
            if(arg .gt.  ru) arg =  ru
            if(arg .lt. -ru) arg = -ru
            sphi = acos(arg) / pi
            if(sy .lt. rzero) sphi = two - sphi
c$$$            if(sphi .lt. sphi_min) return
c$$$            if(sphi .gt. sphi_max) return
            isphi = isphi_of_sphi(sphi)
            I5D(iscth,isphi,ix,iy,iz) =  I5D(iscth,isphi,ix,iy,iz) + du
         end if
      end if

      return
      end
