!DIR$ FIXEDFORMLINESIZE:132
      subroutine wd_pnts_sur_cyl()
      use math_blocks
      use rte_blocks
      use header_types
      use file_types
      implicit none

      character*32 name, call_point
      real*4 cfc
      logical*4 fail
      integer*4 irho

      cfc = weight / (ds*float(nw))

      IF(compute_u) THEN

         uT1D = uT1D * cfc
         do 10, irho=1,Lrho
         uT1D(irho) = uT1D(irho) / float(2*irho-1)
 10      continue

 1       continue

         if(Collimated_Source) then
            name = 'uT_pntc_sur_cyl.asc'
            string%Filetype = ft(5)
         else
            name = 'uT_pnti_sur_cyl.asc'
            string%Filetype = ft(5+nft)
         end if

         call_point = '**** wd_pnts_sur_cyl: u1D ******'
         call dump_gen_1D(name, uT1D, call_point, fail)
         if(fail) then
            write(*,*) 'dump_gen_1D failed to write output'
            write(*,*) 'You may want to check disk space'
            write(*,*) 'To save computed results do not quit'
            write(*,*) 'Instead, continue when ready'
            pause
            goto 1
         end if

      END IF


      IF(compute_J) THEN

         JT2D = JT2D * cfc
         do 20, irho=1,Lrho
         JT2D(1:n0,irho) = JT2D(1:n0,irho) / float(2*irho-1)
 20      continue

 2       continue

         if(Collimated_Source) then
            name = 'JT_pntc_sur_cyl.asc'
            string%Filetype = ft(17)
         else
            name = 'JT_pnti_sur_cyl.asc'
            string%Filetype = ft(17+nft)
         end if

         call dump_J_2D(name, JT2D, fail)
         if(fail) then
            write(*,*) 'dump_J_2D failed to write output'
            write(*,*) 'You may want to check disk space'
            write(*,*) 'To save computed results do not quit'
            write(*,*) 'Instead, continue when ready'
            pause
            goto 2
         end if
      END IF


      IF(compute_I) THEN

         IT3D = IT3D * cfc / (dscth*dsphi*pi)
         call fIe_2D_1D(IT3D)
         do 30, irho=1,Lrho
         IT3D(1:Nscth,1:Nsphi,irho) = IT3D(1:Nscth,1:Nsphi,irho) / float(2*irho-1)
 30      continue

 3       continue

         if(Collimated_Source) then
            name = 'IT_pntc_sur_cyl.bin'
            string%Filetype = ft(29)
         else
            name = 'IT_pnti_sur_cyl.bin'
            string%Filetype = ft(29+nft)
         end if

         call dump_I_2D_1D(name, IT3D, fail)
         if(fail) then
            write(*,*) 'dump_I_2D_1D failed to write output'
            write(*,*) 'You may want to check disk space'
            write(*,*) 'To save computed results do not quit'
            write(*,*) 'Instead, continue when ready'
            pause
            goto 3
         end if
 
      END IF


      return
      end
