!DIR$ FIXEDFORMLINESIZE:132
      subroutine wd_pnts_vol_cyl()
      use math_blocks
      use rte_blocks
      use header_types
      use file_types
      implicit none

      character*32 name
      real*4 cfc
      logical*4 fail
      integer*4 irho

      cfc = weight / (ds*hz*float(nw))  ! ds=pi*hrho*hrho

      IF(compute_u) THEN

         u2D = u2D * cfc

         do 10, irho=1,Lrho
         u2D(irho,1:Lz) = u2D(irho,1:Lz) / float(2*irho-1)
 10      continue

 1       continue

         if(Collimated_Source) then
            name = 'u_pntc_vol_cyl.bin'
            string%Filetype = ft(2)
         else
            name = 'u_pnti_vol_cyl.bin'
            string%Filetype = ft(2+nft)
         end if

         call dump_u_2D(name, u2D, fail)
         if(fail) then
            write(*,*) 'dump_u_2D failed to write output'
            write(*,*) 'You may want to check disk space'
            write(*,*) 'To save computed results do not quit'
            write(*,*) 'Instead, continue when ready'
            pause
            goto 1
         end if

      END IF


      IF(compute_J) THEN

         J3D = J3D * cfc

         do 20, irho=1,Lrho
         J3D(1:n0,irho,1:Lz) = J3D(1:n0,irho,1:Lz) / float(2*irho-1)
 20      continue

 2       continue

         if(Collimated_Source) then
            name = 'J_pntc_vol_cyl.bin'
            string%Filetype = ft(14)
         else
            name = 'J_pnti_vol_cyl.bin'
            string%Filetype = ft(14+nft)
         end if

         call dump_J_3D(name, J3D, fail)
         if(fail) then
            write(*,*) 'dump_J_3D failed to write output'
            write(*,*) 'You may want to check disk space'
            write(*,*) 'To save computed results do not quit'
            write(*,*) 'Instead, continue when ready'
            pause
            goto 2
         end if

      END IF


      IF(compute_I) THEN

         I4D = I4D * cfc / (dscth*dsphi*pi)
         call fIe_2D_2D(I4D)

         do 30, irho=1,Lrho
         I4D(1:Nscth,1:Nsphi,irho,1:Lz) = I4D(1:Nscth,1:Nsphi,irho,1:Lz) / float(2*irho-1)
 30      continue

 3       continue

         if(Collimated_Source) then
            name = 'I_pntc_vol_cyl.bin'
            string%Filetype = ft(26)
         else
            name = 'I_pnti_vol_cyl.bin'
            string%Filetype = ft(26+nft)
         end if

         write(*,*) 'Writing data can take a little time... Wait a bit...'

         call dump_I_2D_2D(name, I4D, fail)
         if(fail) then
            write(*,*) 'dump_I_2D_2D failed to write output'
            write(*,*) 'You may want to check disk space'
            write(*,*) 'To save computed results do not quit'
            write(*,*) 'Instead, continue when ready'
            pause
            goto 3
         end if
 
      END IF


      return
      end
